import { world } from "@minecraft/server";

export default {
  name: "givechest",
  description: "Give a player a specific chest type and amount.",
  aliases: ["gchest", "gc"],
  op: true,
  run: (chat, player, args) => {
    if (args.length < 2) {
      return player.sendMessage("§cUsage: !givechest <type> <amount>");
    }

    const chestType = args[0].toLowerCase();
    const amount = parseInt(args[1]);

    const validTypes = ["reward", "quest", "weekly"];
    if (!validTypes.includes(chestType)) {
      return player.sendMessage("§cInvalid chest type. Use reward, quest, or weekly.");
    }

    if (isNaN(amount) || amount <= 0) {
      return player.sendMessage("§cInvalid amount. Must be a number greater than 0.");
    }

    const chests = JSON.parse(player.getDynamicProperty("chests") ?? "{}");

    chests[chestType] = (chests[chestType] ?? 0) + amount;

    player.setDynamicProperty("chests", JSON.stringify(chests));

    player.sendMessage(`§aGiven §l${amount}§r§a ${chestType} chest(s).`);
  }
};
