import { config } from "../variables/config";
import { commandRegistry } from "../cmds/index.js";

export default {
  name: "chatSend",
  type: 0,
  run: async (chat, db) => {
    if (!chat.message.startsWith(config.prefix)) return;

    chat.cancel = true;

    const player = chat.sender;
    const message = chat.message;
    const args = message.slice(config.prefix.length).trim().split(/ +/g);
    const cmdName = args.shift().toLowerCase();

    const command = commandRegistry.find(cmd =>
      cmd.name === cmdName || (cmd.aliases && cmd.aliases.includes(cmdName))
    );

    if (!command) {
      player.sendMessage(`§cUnknown command "${cmdName}". Please refer to ${config.prefix}help for more info.`);
      return;
    }
    
    if(command.op && !player.isOp()) return player.sendMessage('§cThis command is for players with Operator permissions only.')

    try {
      await command.run(chat, player, args, db);
    } catch (err) {
      console.error(`Error executing command "${cmdName}":`, err);
      player.sendMessage("§cAn error occurred while executing the command.");
    }
  }
};
