import { kill, place, destroy, consume, shoot } from "../variables/quests.js";
import { world } from "@minecraft/server";

export default {
  name: "playerSpawn",
  type: 1,
  run: async(data) => {
    if(!data.initialSpawn) return;
    
    const config = JSON.parse(world.getDynamicProperty("stk.config") ?? "{}");

    if (config.quest === false) return; 
    
    const now = new Date().toLocaleDateString();
    
    let lqd = data.player.getDynamicProperty("quest.date");
  if(!lqd) {
    const nd = new Date();
    nd.setDate(nd.getDate() - 1);
    const formattedPrev = nd.toLocaleDateString();
    
    lqd = data.player.setDynamicProperty("quest.date", formattedPrev)
  }
  
  if (lqd === now) return;   
  const questData = {
    kill,
    place,
    destroy,
    consume,
    shoot
  }; 
  
  const categories = Object.keys(questData);
  const selected = categories.sort(() => 0.5 - Math.random()).slice(0, 3);

  const quests = selected.map(cat => {
    const pool = questData[cat];
    const choice = pool[Math.floor(Math.random() * pool.length)];
    return {
      ...choice,
      category: cat,
      amount: choice.amount,
      typeId: choice.typeId,
      current: 0,
      completed: false
    };
  });


  data.player.setDynamicProperty("quest.list", JSON.stringify(quests));
  data.player.setDynamicProperty("quest.date", now);
  data.player.setDynamicProperty("quest.claimed", false)
  }
}